-- frmMain.lua
-- Written by Habna


function frmMain()
	self = Turbine.UI.Window();
	self.WasDrag = false;
	self:SetSize( 24, 24 );
	local screenWidth, screenHeight = Turbine.UI.Display.GetSize()
	local winWidth, winHeight = self:GetSize();

	settings = {};
	settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "HugeBagUtilitiesSettings" );
	
	if settings == nil then
		self:SetPosition( screenWidth - winWidth - 90, screenHeight - winHeight - 40 );
		SaveSettings();
	end
	
	self:SetPosition( settings.Location.X, settings.Location.Y );
	self:SetVisible( true );

	reloadButton = Turbine.UI.Button();
	reloadButton:SetParent( self );
	reloadButton:SetPosition( 0, 0 );
	reloadButton:SetSize( self:GetWidth(), self:GetHeight() );
	reloadButton:SetBackground( "HabnaPlugins/HugeBag/Resources/reload.tga" );

	reloadButton.Click = function( sender, args )
		if ( not self.WasDrag ) then
			ReloadHugeBag()
		end
		self.WasDrag = false;
	end

	reloadButton.MouseDown = function( sender, args )
		self.dragStartX = args.X;
		self.dragStartY = args.Y;
		self.dragging = true;
	end
	
	reloadButton.MouseUp = function( sender, args )
		local screenWidth, screenHeight = Turbine.UI.Display.GetSize()
		if self:GetLeft() < 0 then self:SetLeft( 0 ) end
		if self:GetLeft() + self:GetWidth() > screenWidth then self:SetLeft( screenWidth - self:GetWidth() ) end
		if self:GetTop() < 0 then self:SetTop( 0 ) end
		if self:GetTop() + self:GetHeight() > screenHeight then self:SetTop( screenHeight - self:GetHeight() ) end
		self.dragging = false;
		SaveSettings()
	end
	
	reloadButton.MouseMove = function( sender, args )
		local left, top = self:GetPosition();
  		
		if ( self.dragging ) then
			self:SetPosition( left + ( args.X - self.dragStartX ), top + ( args.Y - self.dragStartY ) );
			self.WasDrag = true;
		end
	end
end

function SaveSettings()
	settings = {};
	
	settings.Location = {};
	settings.Location.X = self:GetLeft();
	settings.Location.Y = self:GetTop();

	Turbine.PluginData.Save( Turbine.DataScope.Character, "HugeBagUtilitiesSettings", settings );
end

function ReloadHugeBag()
	Turbine.PluginManager.RefreshAvailablePlugins()
	local loaded_plugins = Turbine.PluginManager.GetLoadedPlugins()
	local foundHugeBag = false;
	local foundWrapper = false;

	for k,v in pairs(loaded_plugins) do
		if v.Name == "HugeBag" then
			foundHugeBag = true;
		elseif v.Name == "HugeBag Wrapper" then
			foundWrapper = true;
		end
	end

	if not foundWrapper then
		if foundHugeBag then
			Turbine.PluginManager.UnloadScriptState( "HugeBag" );
			Turbine.PluginManager.LoadPlugin("HugeBag");
			write( "HugeBag Utilities: HugeBag was reloaded" );
		end
	else
		write( "HugeBag Utilities: Unable to reload HugeBag when the wrapper is loaded" );
	end

	if not foundHugeBag and not foundWrapper then
		write( "HugeBag Utilities: Reload aborted, Nothing is loaded" );
	end
end

function ResetLoc()
	local screenWidth, screenHeight = Turbine.UI.Display.GetSize()
	local winWidth, winHeight = self:GetSize();
	self:SetPosition( screenWidth - winWidth - 90, screenHeight - winHeight - 40 );
	SaveSettings()
end